diff -r f77229934d59 src/org/armedbear/lisp/Pathname.java
--- a/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:34:38 2010 +0100
@@ -30,93 +30,89 @@
  * obligated to do so.  If you do not wish to do so, delete this
  * exception statement from your version.
  */
-
 package org.armedbear.lisp;
 
+import java.util.logging.Level;
+import java.util.logging.Logger;
 import static org.armedbear.lisp.Lisp.*;
 
 import java.io.File;
 import java.io.IOException;
+import java.io.InputStream;
+import java.io.FileInputStream;
+import java.net.JarURLConnection;
+import java.net.MalformedURLException;
 import java.net.URL;
+import java.net.URLConnection;
 import java.net.URLDecoder;
 import java.util.StringTokenizer;
+import java.util.jar.JarEntry;
+import java.util.jar.JarFile;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipFile;
+import java.util.zip.ZipInputStream;
 
-public class Pathname extends LispObject
-{
+public class Pathname extends LispObject {
+
     protected LispObject host = NIL;
     protected LispObject device = NIL;
     protected LispObject directory = NIL;
     protected LispObject name = NIL;
-
     // A string, NIL, :WILD or :UNSPECIFIC.
     protected LispObject type = NIL;
-
     // A positive integer, or NIL, :WILD, :UNSPECIFIC, or :NEWEST.
     protected LispObject version = NIL;
 
     private String namestring;
-
-    protected Pathname()
-    {
+    public void invalidateNamestring() {
+        namestring = null;
     }
 
-    public Pathname(String s)
-    {
+    protected Pathname() {
+    }
+
+    public Pathname(String s) {
         init(s);
     }
 
-    public Pathname(URL url)
-    {
+    public Pathname(URL url) {
         String protocol = url.getProtocol();
         if ("jar".equals(protocol)) {
-            String s;
-            try {
-                s = URLDecoder.decode(url.getPath(),"UTF-8");
-            }
-            catch (java.io.UnsupportedEncodingException uee) {
-                // Can't happen: every Java is supposed to support
-                // at least UTF-8 encoding
-                s = null;
-            }
-            if (s.startsWith("file:")) {
-                int index = s.indexOf("!/");
-                String container = s.substring(5, index);
-                if (Utilities.isPlatformWindows) {
-                    if (container.length() > 0 && container.charAt(0) == '/')
-                        container = container.substring(1);
-                }
-                device = new Pathname(container);
-                s = s.substring(index + 1);
-                Pathname p = new Pathname(s);
-                directory = p.directory;
-                name = p.name;
-                type = p.type;
-                return;
-            }
+            init(url.toString());
+            return;
         } else if ("file".equals(protocol)) {
             String s;
             try {
-                s = URLDecoder.decode(url.getPath(),"UTF-8");
-            }
-            catch (java.io.UnsupportedEncodingException uee) {
+                s = URLDecoder.decode(url.getPath(), "UTF-8");
+            } catch (java.io.UnsupportedEncodingException uee) {
                 // Can't happen: every Java is supposed to support
                 // at least UTF-8 encoding
+                Debug.assertTrue(false);
                 s = null;
             }
-            if (s != null && s.startsWith("file:")) {
-                init(s.substring(5));
+            if (s != null) {
+		if (Utilities.isPlatformWindows) {
+		    //  Workaround bug in Java's idea of URLs
+		    //  new (URL"file:///c:/a/b").getPath() --> "/c:/a/b"
+		    if (s.length() > 2 
+			&& s.charAt(0) == '/'
+			&& s.charAt(2) == ':') {
+			s = s.substring(1);
+		    }
+		}
+                init(s);
                 return;
             }
         }
-        error(new LispError("Unsupported URL: \"" + url.toString() + '"'));
+        error(new LispError("Unsupported URL: '" + url.toString() + "'"));
     }
 
-    private final void init(String s)
-    {
-        if (s == null)
+    private final void init(String s) {
+        if (s == null) {
             return;
-        if (s.equals(".") || s.equals("./") ||
-            (Utilities.isPlatformWindows && s.equals(".\\"))) {
+        }
+        if (s.equals(".") || s.equals("./")
+          || (Utilities.isPlatformWindows && s.equals(".\\"))) {
             directory = new Cons(Keyword.RELATIVE);
             return;
         }
@@ -126,50 +122,132 @@
         }
         if (Utilities.isPlatformWindows) {
             if (s.startsWith("\\\\")) {
-               //UNC path support
-               // match \\<server>\<share>\[directories-and-files]
+                //UNC path support
+                // match \\<server>\<share>\[directories-and-files]
 
-               int shareIndex = s.indexOf('\\', 2);
-               int dirIndex = s.indexOf('\\', shareIndex + 1);
+                int shareIndex = s.indexOf('\\', 2);
+                int dirIndex = s.indexOf('\\', shareIndex + 1);
 
-               if (shareIndex == -1 || dirIndex == -1)
-                  error(new LispError("Unsupported UNC path format: \"" + s + '"'));
+                if (shareIndex == -1 || dirIndex == -1) {
+                    error(new LispError("Unsupported UNC path format: \"" + s + '"'));
+                }
 
-               host = new SimpleString(s.substring(2, shareIndex));
-               device = new SimpleString(s.substring(shareIndex + 1, dirIndex));
+                host = new SimpleString(s.substring(2, shareIndex));
+                device = new SimpleString(s.substring(shareIndex + 1, dirIndex));
 
-               Pathname p = new Pathname(s.substring(dirIndex));
-               directory = p.directory;
-               name = p.name;
-               type = p.type;
-               version = p.version;
-               return;
+                Pathname p = new Pathname(s.substring(dirIndex));
+                directory = p.directory;
+                name = p.name;
+                type = p.type;
+                version = p.version;
+                return;
             }
+    }
 
-            s = s.replace('/', '\\');
-        }
-        // Jar file support.
-        int bang = s.indexOf("!/");
-        if (bang >= 0) {
-            Pathname container = new Pathname(s.substring(0, bang));
-            LispObject containerType = container.type;
-            if (containerType instanceof AbstractString) {
-                if (containerType.getStringValue().equalsIgnoreCase("jar")) {
-                    device = container;
-                    s = s.substring(bang + 1);
-                    Pathname p = new Pathname(s);
-                    directory = p.directory;
-                    name = p.name;
-                    type = p.type;
-                    return;
+        final String separator = "!/";
+
+        // A JAR file
+        if (s.startsWith("jar:") && s.endsWith(separator)) {
+            LispObject jars = NIL;
+            int i = s.lastIndexOf(separator, s.length() - separator.length() - 1);
+            String jar = null;
+            if (i == -1) {
+                jar = s;
+            } else {
+                // There can be no more than two jar references and the
+                // inner one must be a file reference within the outer.
+                jar = "jar:file:" + s.substring(i + separator.length());
+                s = s.substring("jar:".length(), i + separator.length());
+                Pathname p = new Pathname(s);
+                LispObject first = ((Cons) p.device).car();
+                if (first instanceof AbstractString) {
+                    jars = jars.push(first);
+                } else {
+                    jars = jars.push(p.device.car());
                 }
             }
+            if (jar.startsWith("jar:file:")) {
+                String jarString = jar.substring("jar:".length(),
+                  jar.length() - separator.length());
+                // Use URL constructor to normalize Windows' use of device
+                URL url = null;
+                try {
+                    url = new URL(jarString);
+                } catch (MalformedURLException e) {
+                    error(new LispError("Failed to parse '" + jarString + "'"
+                            + " as URL:"
+                            + e.getMessage()));
+                }
+                Pathname jarPathname = new Pathname(url);
+                if (jarString.endsWith(separator)) {
+                    jars = jars.push(jarPathname.device);
+                } else {
+                    jars = jars.push(jarPathname);
+                }
+            } else {
+                URL url = null;
+                try {
+                    url = new URL(jar.substring("jar:".length(), jar.length() - 2));
+                    jars = jars.push(new SimpleString(url.toString()));
+                } catch (MalformedURLException e) {
+                    error(new LispError("Failed to parse url '" + url + "'"
+                      + e.getMessage()));
+                }
+            }
+            jars = jars.nreverse();
+            device = jars;
+            return;
         }
+
+        // An entry in a JAR file
+        final int separatorIndex = s.lastIndexOf(separator);
+        if (separatorIndex > 0 && s.startsWith("jar:")) {
+            final String jarURL = s.substring(0, separatorIndex + separator.length());
+            Pathname d = new Pathname(jarURL);
+            if (device instanceof Cons) {
+                LispObject[] jars = d.copyToArray();
+                //  XXX Is this ever not true?  If so, need to append lists
+                Debug.assertTrue(false);
+            } else {
+                device = d.device;
+            }
+            s = s.substring(separatorIndex + separator.length());
+            Pathname p = new Pathname(s);
+            directory = p.directory;
+            name = p.name;
+            type = p.type;
+            version = p.version;
+            return;
+        }
+
+        if (Utilities.isPlatformWindows) {
+            if (!s.contains("!/")) {
+                s = s.replace("/", "\\");
+            } else {
+              StringBuilder result = new StringBuilder();
+              for (int i = 0; i < s.length(); i++) {
+                  char c = s.charAt(i);
+                  if ( c != '/') {
+                      result.append(c);
+                  } else {
+                      if (i != 0 && s.charAt(i-1) != '!') {
+                          result.append("\\");
+                      } else {
+                          result.append(c);
+                      }
+                  }
+              }
+              s = result.toString();
+            }
+        }
+
+        // Expand user home directories
         if (Utilities.isPlatformUnix) {
-            if (s.equals("~"))
+            if (s.equals("~")) {
                 s = System.getProperty("user.home").concat("/");
-            else if (s.startsWith("~/"))
+            } else if (s.startsWith("~/")) {
                 s = System.getProperty("user.home").concat(s.substring(1));
+            }
         }
         namestring = s;
         if (Utilities.isPlatformWindows) {
@@ -215,56 +293,59 @@
         if (index > 0) {
             n = s.substring(0, index);
             t = s.substring(index + 1);
-        } else if (s.length() > 0)
+        } else if (s.length() > 0) {
             n = s;
+        }
         if (n != null) {
-            if (n.equals("*"))
+            if (n.equals("*")) {
                 name = Keyword.WILD;
-            else
+            } else {
                 name = new SimpleString(n);
+            }
         }
         if (t != null) {
-            if (t.equals("*"))
+            if (t.equals("*")) {
                 type = Keyword.WILD;
-            else
+            } else {
                 type = new SimpleString(t);
+            }
         }
     }
 
-    private static final LispObject parseDirectory(String d)
-
-    {
-        if (d.equals("/") || (Utilities.isPlatformWindows && d.equals("\\")))
+    private static final LispObject parseDirectory(String d) {
+        if (d.equals("/") || (Utilities.isPlatformWindows && d.equals("\\"))) {
             return new Cons(Keyword.ABSOLUTE);
+        }
         LispObject result;
-        if (d.startsWith("/") || (Utilities.isPlatformWindows && d.startsWith("\\")))
+        if (d.startsWith("/") || (Utilities.isPlatformWindows && d.startsWith("\\"))) {
             result = new Cons(Keyword.ABSOLUTE);
-        else
+        } else {
             result = new Cons(Keyword.RELATIVE);
+        }
         StringTokenizer st = new StringTokenizer(d, "/\\");
         while (st.hasMoreTokens()) {
             String token = st.nextToken();
             LispObject obj;
-            if (token.equals("*"))
+            if (token.equals("*")) {
                 obj = Keyword.WILD;
-            else if (token.equals("**"))
+            } else if (token.equals("**")) {
                 obj = Keyword.WILD_INFERIORS;
-            else if (token.equals("..")) {
+            } else if (token.equals("..")) {
                 if (result.car() instanceof AbstractString) {
                     result = result.cdr();
                     continue;
                 }
-                obj= Keyword.UP;
-            } else
+                obj = Keyword.UP;
+            } else {
                 obj = new SimpleString(token);
+            }
             result = new Cons(obj, result);
         }
         return result.nreverse();
     }
 
     @Override
-    public LispObject getParts()
-    {
+    public LispObject getParts() {
         LispObject parts = NIL;
         parts = parts.push(new Cons("HOST", host));
         parts = parts.push(new Cons("DEVICE", device));
@@ -276,42 +357,41 @@
     }
 
     @Override
-    public LispObject typeOf()
-    {
+    public LispObject typeOf() {
         return Symbol.PATHNAME;
     }
 
     @Override
-    public LispObject classOf()
-    {
+    public LispObject classOf() {
         return BuiltInClass.PATHNAME;
     }
 
     @Override
-    public LispObject typep(LispObject type)
-    {
-        if (type == Symbol.PATHNAME)
+    public LispObject typep(LispObject type) {
+        if (type == Symbol.PATHNAME) {
             return T;
-        if (type == BuiltInClass.PATHNAME)
+        }
+        if (type == BuiltInClass.PATHNAME) {
             return T;
+        }
         return super.typep(type);
     }
 
-    public final LispObject getDevice()
-    {
+    public final LispObject getDevice() {
         return device;
     }
 
-    public String getNamestring()
-    {
-        if (namestring != null)
+    public String getNamestring() {
+        if (namestring != null) {
             return namestring;
+        }
         if (name == NIL && type != NIL) {
             Debug.assertTrue(namestring == null);
             return null;
         }
-        if (directory instanceof AbstractString)
+        if (directory instanceof AbstractString) {
             Debug.assertTrue(false);
+        }
         FastStringBuffer sb = new FastStringBuffer();
         // "If a pathname is converted to a namestring, the symbols NIL and
         // :UNSPECIFIC cause the field to be treated as if it were empty. That
@@ -319,26 +399,51 @@
         // the namestring." 19.2.2.2.3.1
         if (host != NIL) {
             Debug.assertTrue(host instanceof AbstractString);
-            if (! (this instanceof LogicalPathname))
-               sb.append("\\\\"); //UNC file support; if there's a host, it's a UNC path.
+            if (!(this instanceof LogicalPathname)) {
+                sb.append("\\\\"); //UNC file support; if there's a host, it's a UNC path.
+            }
             sb.append(host.getStringValue());
-            if (this instanceof LogicalPathname)
-              sb.append(':');
-            else
-              sb.append(File.separatorChar);
+            if (this instanceof LogicalPathname) {
+                sb.append(':');
+            } else {
+                sb.append(File.separatorChar);
+            }
         }
         if (device == NIL) {
         } else if (device == Keyword.UNSPECIFIC) {
+        } else if (device instanceof Cons) {
+            LispObject[] jars = ((Cons) device).copyToArray();
+            int i = 0;
+            if (jars[0] instanceof AbstractString) {
+                sb.append("jar:");
+                sb.append(((AbstractString) jars[0]).getStringValue());
+                sb.append("!/");
+                i = 1;
+            }
+            FastStringBuffer prefix = new FastStringBuffer();
+            for (; i < jars.length; i++) {
+                prefix.append("jar:");
+                if (i == 0) {
+                    sb.append("file:");
+                }
+                if (jars[i] instanceof Pathname) {
+                    sb.append(((Pathname) jars[i]).getNamestring());
+                }
+                sb.append("!/");
+            }
+            sb = prefix.append(sb);
+        } else if (device instanceof AbstractString
+          && device.getStringValue().startsWith("jar:")) {
+            sb.append(device.getStringValue());
         } else if (device instanceof AbstractString) {
             sb.append(device.getStringValue());
             if (this instanceof LogicalPathname
-                || host == NIL)
-              sb.append(':'); // non-UNC paths
-        } else if (device instanceof Pathname) {
-            sb.append(((Pathname)device).getNamestring());
-            sb.append("!");
-        } else
+              || host == NIL) {
+                sb.append(':'); // non-UNC paths
+            }
+        } else {
             Debug.assertTrue(false);
+        }
         sb.append(getDirectoryNamestring());
         if (name instanceof AbstractString) {
             String n = name.getStringValue();
@@ -347,8 +452,9 @@
                 return null;
             }
             sb.append(n);
-        } else if (name == Keyword.WILD)
+        } else if (name == Keyword.WILD) {
             sb.append('*');
+        }
         if (type != NIL) {
             sb.append('.');
             if (type instanceof AbstractString) {
@@ -358,19 +464,21 @@
                     return null;
                 }
                 sb.append(t);
-            } else if (type == Keyword.WILD)
+            } else if (type == Keyword.WILD) {
                 sb.append('*');
-            else
+            } else {
                 Debug.assertTrue(false);
+            }
         }
         if (this instanceof LogicalPathname) {
             if (version.integerp()) {
                 sb.append('.');
                 int base = Fixnum.getValue(Symbol.PRINT_BASE.symbolValue());
-                if (version instanceof Fixnum)
-                    sb.append(Integer.toString(((Fixnum)version).value, base).toUpperCase());
-                else if (version instanceof Bignum)
-                    sb.append(((Bignum)version).value.toString(base).toUpperCase());
+                if (version instanceof Fixnum) {
+                    sb.append(Integer.toString(((Fixnum) version).value, base).toUpperCase());
+                } else if (version instanceof Bignum) {
+                    sb.append(((Bignum) version).value.toString(base).toUpperCase());
+                }
             } else if (version == Keyword.WILD) {
                 sb.append(".*");
             } else if (version == Keyword.NEWEST) {
@@ -380,8 +488,7 @@
         return namestring = sb.toString();
     }
 
-    protected String getDirectoryNamestring()
-    {
+    protected String getDirectoryNamestring() {
         validateDirectory(true);
         FastStringBuffer sb = new FastStringBuffer();
         // "If a pathname is converted to a namestring, the symbols NIL and
@@ -390,10 +497,11 @@
         // the namestring." 19.2.2.2.3.1
         if (directory != NIL) {
             final char separatorChar;
-            if (device instanceof Pathname)
+            if (device instanceof Cons) {
                 separatorChar = '/'; // Jar file.
-            else
+            } else {
                 separatorChar = File.separatorChar;
+            }
             LispObject temp = directory;
             LispObject part = temp.car();
             temp = temp.cdr();
@@ -407,23 +515,24 @@
                 }
                 // else: Nothing to do.
             } else {
-                error(new FileError("Unsupported directory component " +
-                                    part.writeToString() + ".",
-                                    this));
+                error(new FileError("Unsupported directory component "
+                  + part.writeToString() + ".",
+                  this));
             }
             while (temp != NIL) {
                 part = temp.car();
-                if (part instanceof AbstractString)
+                if (part instanceof AbstractString) {
                     sb.append(part.getStringValue());
-                else if (part == Keyword.WILD)
+                } else if (part == Keyword.WILD) {
                     sb.append('*');
-                else if (part == Keyword.WILD_INFERIORS)
+                } else if (part == Keyword.WILD_INFERIORS) {
                     sb.append("**");
-                else if (part == Keyword.UP)
+                } else if (part == Keyword.UP) {
                     sb.append("..");
-                else
+                } else {
                     error(new FileError("Unsupported directory component " + part.writeToString() + ".",
-                                        this));
+                      this));
+                }
                 sb.append(separatorChar);
                 temp = temp.cdr();
             }
@@ -431,39 +540,71 @@
         return sb.toString();
     }
 
+    /** @return The representation of this pathname suitable for referencing an entry in a Zip/JAR file */
+    protected String asEntryPath() {
+        Pathname p = new Pathname();
+        p.directory = directory;
+        p.name = name;
+        p.type = type;
+        String path = p.getNamestring();
+        if (Utilities.isPlatformWindows) {
+	    StringBuilder result = new StringBuilder();
+	    for (int i = 0; i < path.length(); i++) {
+		char c = path.charAt(i);
+		if (c == '\\') {
+		    result.append('/');
+		} else {
+		    result.append(c);
+		}
+	    }
+	    return result.toString();
+        }
+        return path;
+    }
+
     @Override
-    public boolean equal(LispObject obj)
-    {
-        if (this == obj)
+    public boolean equal(LispObject obj) {
+        if (this == obj) {
             return true;
+        }
         if (obj instanceof Pathname) {
             Pathname p = (Pathname) obj;
             if (Utilities.isPlatformWindows) {
-                if (!host.equalp(p.host))
+                if (!host.equalp(p.host)) {
                     return false;
-                if (!device.equalp(p.device))
+                }
+                if (!device.equalp(p.device)) {
                     return false;
-                if (!directory.equalp(p.directory))
+                }
+                if (!directory.equalp(p.directory)) {
                     return false;
-                if (!name.equalp(p.name))
+                }
+                if (!name.equalp(p.name)) {
                     return false;
-                if (!type.equalp(p.type))
+                }
+                if (!type.equalp(p.type)) {
                     return false;
+                }
                 // Ignore version component.
                 //if (!version.equalp(p.version))
                 //    return false;
             } else {
                 // Unix.
-                if (!host.equal(p.host))
+                if (!host.equal(p.host)) {
                     return false;
-                if (!device.equal(p.device))
+                }
+                if (!device.equal(p.device)) {
                     return false;
-                if (!directory.equal(p.directory))
+                }
+                if (!directory.equal(p.directory)) {
                     return false;
-                if (!name.equal(p.name))
+                }
+                if (!name.equal(p.name)) {
                     return false;
-                if (!type.equal(p.type))
+                }
+                if (!type.equal(p.type)) {
                     return false;
+                }
                 // Ignore version component.
                 //if (!version.equal(p.version))
                 //    return false;
@@ -474,24 +615,21 @@
     }
 
     @Override
-    public boolean equalp(LispObject obj)
-    {
+    public boolean equalp(LispObject obj) {
         return equal(obj);
     }
 
     @Override
-    public int sxhash()
-    {
-        return ((host.sxhash() ^
-                 device.sxhash() ^
-                 directory.sxhash() ^
-                 name.sxhash() ^
-                 type.sxhash()) & 0x7fffffff);
+    public int sxhash() {
+        return ((host.sxhash()
+          ^ device.sxhash()
+          ^ directory.sxhash()
+          ^ name.sxhash()
+          ^ type.sxhash()) & 0x7fffffff);
     }
 
     @Override
-    public String writeToString()
-    {
+    public String writeToString() {
         final LispThread thread = LispThread.currentThread();
         boolean printReadably = (Symbol.PRINT_READABLY.symbolValue(thread) != NIL);
         boolean printEscape = (Symbol.PRINT_ESCAPE.symbolValue(thread) != NIL);
@@ -507,47 +645,52 @@
                     useNamestring = false;
                 } else if (name instanceof AbstractString) {
                     String n = name.getStringValue();
-                    if (n.equals(".") || n.equals(".."))
+                    if (n.equals(".") || n.equals("..")) {
                         useNamestring = false;
-                    else if (n.indexOf(File.separatorChar) >= 0)
+                    } else if (n.indexOf(File.separatorChar) >= 0) {
                         useNamestring = false;
+                    }
                 }
             }
-        } else
-           useNamestring = false;
+        } else {
+            useNamestring = false;
+        }
         FastStringBuffer sb = new FastStringBuffer();
         if (useNamestring) {
-            if (printReadably || printEscape)
+            if (printReadably || printEscape) {
                 sb.append("#P\"");
+            }
             final int limit = s.length();
             for (int i = 0; i < limit; i++) {
                 char c = s.charAt(i);
                 if (printReadably || printEscape) {
-                    if (c == '\"' || c == '\\')
+                    if (c == '\"' || c == '\\') {
                         sb.append('\\');
+                    }
                 }
                 sb.append(c);
             }
-            if (printReadably || printEscape)
+            if (printReadably || printEscape) {
                 sb.append('"');
+            }
         } else {
             sb.append("#P(");
             if (host != NIL) {
                 sb.append(":HOST ");
                 sb.append(host.writeToString());
                 sb.append(' ');
-           }
-           if (device != NIL) {
-               sb.append(":DEVICE ");
-               sb.append(device.writeToString());
-               sb.append(' ');
+            }
+            if (device != NIL) {
+                sb.append(":DEVICE ");
+                sb.append(device.writeToString());
+                sb.append(' ');
             }
             if (directory != NIL) {
                 sb.append(":DIRECTORY ");
                 sb.append(directory.writeToString());
                 sb.append(" ");
             }
-           if (name != NIL) {
+            if (name != NIL) {
                 sb.append(":NAME ");
                 sb.append(name.writeToString());
                 sb.append(' ');
@@ -562,31 +705,26 @@
                 sb.append(version.writeToString());
                 sb.append(' ');
             }
-            if (sb.charAt(sb.length() - 1) == ' ')
+            if (sb.charAt(sb.length() - 1) == ' ') {
                 sb.setLength(sb.length() - 1);
+            }
             sb.append(')');
-         }
-         return sb.toString();
+        }
+        return sb.toString();
     }
-
     // A logical host is represented as the string that names it.
     // (defvar *logical-pathname-translations* (make-hash-table :test 'equal))
     public static EqualHashTable LOGICAL_PATHNAME_TRANSLATIONS =
-        new EqualHashTable(64, NIL, NIL);
+      new EqualHashTable(64, NIL, NIL);
+    private static final Symbol _LOGICAL_PATHNAME_TRANSLATIONS_ =
+      exportSpecial("*LOGICAL-PATHNAME-TRANSLATIONS*", PACKAGE_SYS,
+      LOGICAL_PATHNAME_TRANSLATIONS);
 
-    private static final Symbol _LOGICAL_PATHNAME_TRANSLATIONS_ =
-        exportSpecial("*LOGICAL-PATHNAME-TRANSLATIONS*", PACKAGE_SYS,
-                      LOGICAL_PATHNAME_TRANSLATIONS);
-
-    public static Pathname parseNamestring(String s)
-
-    {
+    public static Pathname parseNamestring(String s) {
         return new Pathname(s);
     }
 
-    public static Pathname parseNamestring(AbstractString namestring)
-
-    {
+    public static Pathname parseNamestring(AbstractString namestring) {
         // Check for a logical pathname host.
         String s = namestring.getStringValue();
         String h = getHostString(s);
@@ -598,17 +736,15 @@
     }
 
     public static Pathname parseNamestring(AbstractString namestring,
-                                           AbstractString host)
-
-    {
+      AbstractString host) {
         // Look for a logical pathname host in the namestring.
         String s = namestring.getStringValue();
         String h = getHostString(s);
         if (h != null) {
             if (!h.equals(host.getStringValue())) {
-                error(new LispError("Host in " + s +
-                                    " does not match requested host " +
-                                    host.getStringValue()));
+                error(new LispError("Host in " + s
+                  + " does not match requested host "
+                  + host.getStringValue()));
                 // Not reached.
                 return null;
             }
